#asm
    .equ __i2c_port=0x15
    .equ __sda_bit=4
    .equ __scl_bit=5
#endasm

#include <mega8.h>
#include <delay.h>
#include <iobits.h>
#include <i2c.h>
#include <ds1307.h>
#include "max7221.c"

#define Motor_on SETBIT(PORTD,4)
#define Motor_off CLRBIT(PORTD,4)

#define TSTBTN TSTBIT(PIND,2)   //  

#define RES 130     // 

#define LED_PORT PORTB
#define RED 0
#define BLUE 1
#define GREEN 2

#define RGB_PORT PORTD
#define RD 6
#define BL 5
#define GR 7

#define COLORS 11 //( -1)

#define LEDON SETBIT(PORTC,3)
#define LEDOFF CLRBIT(PORTC,3)

/**************UART**********************/
#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<DOR)

// USART Receiver buffer
#define RX_BUFFER_SIZE 100
char rx_buf[RX_BUFFER_SIZE];      //   

unsigned char rx_wr_index=0;

unsigned char RXj;      // 
flash char str[]="$GPRMC";

/**************************************/

unsigned char BTNdur;         //  
bit Short_Press, Long_Press, Button_f;   //  ,  , 
bit tst;                    //  

unsigned char NewStateEnc, OldStateEnc, upEnc, downEnc; // 
unsigned char tmpEnc=0;                                   //    

unsigned char hour, min, sek;   //
unsigned char hh;               //   
unsigned char GPShour, GPSmin, GPSsek; // GPS
unsigned char GPSday, GPSmonth, GPSyear; // GPS
unsigned char old_day;
unsigned char week_day, day, month, year; //
bit sync_start=1;     //  
bit uart=0;           //UART 

unsigned char zone; // 

bit set=0;  //  (0 - , 1 - )
bit dot;    //  (0-, 1-)
bit t;      // (1 -  )
bit gps=0;  //   

unsigned char old_sek, old_min;
bit s_f;    //  
bit m_f;    //  

unsigned char count;                 //   /0
  
unsigned int turn;                    //   
unsigned char sekynda;                //     
unsigned int on;                      //  


unsigned char rgb[]={0,0,0};    // 5 - , 6 - , 7 -  
unsigned char pwm;            //  5 - , 6 - , 7 - 
unsigned char rgbN;             // 

unsigned char sat;       //

eeprom unsigned char EEtimezone=5;
eeprom unsigned char EErgbN=0;
eeprom unsigned char EEsyncday=32;
eeprom unsigned char EEsat=0x07;
eeprom unsigned char EErgb[]={0,0,254,0,254,0,254,0,0,0,254,254,254,0,254,254,254,0,0,254,127,254,0,127,254,127,0,0,127,254,64,64,0,127,127,127};
//254 -             ||  |   ||   |    |  |   ||| 


// char   (  )
char char2bin(char c)
{
c = (c - '0');
return (c);
}

//   2 
char getdec (char a, char b)
{
return char2bin(rx_buf[a])*10+char2bin(rx_buf[b]);
}

//  
char comma (char com)
{
unsigned char i=0, j=0;
for (j=0;j<com;j++) {
    while (rx_buf[i++]!=',');
                    }
return i;
}

/*
//   
char rel(void)
{
if(rx_buf[comma(2)] == 'A')
    return 1;
    else
    return 0;                                       
}
*/
//   
char rel(void)
{
if(rx_buf[7] == ',')
    return 0;
    else
    return 1;                                       
}

// 
void find_time(void)
{
char tmp;
tmp=comma(1);
GPShour=getdec(tmp, tmp+1);
GPSmin=getdec(tmp+2, tmp+3);
GPSsek=getdec(tmp+4, tmp+5);
tmp=comma(9);
GPSday=getdec(tmp, tmp+1);
GPSmonth=getdec(tmp+2, tmp+3);
GPSyear=getdec(tmp+4, tmp+5);                                       
}

// 
void gps_parse(void)
{
unsigned char i;
bit equal=0;
RXj = 0;
for (i=0;i<6;i++) {if (rx_buf[i]==str[i]) equal=1; else equal=0; }    
if (equal) {        //  
    if(rel()) {     //  
       find_time(); //   
       gps=1;       // 
               }
            }                                              
}

// 
void BUTTON(void)
{
BTNdur++;
if (BTNdur==2) tst=TSTBTN;         
if (BTNdur==31) {                               // 500 
    if (!tst) {if (TSTBTN) Short_Press=1; else Long_Press=1;}   //   0,   ,  
    Button_f=0;     
    GICR|=0x40;
    GIFR|=0x40;       // 
                }
}

// 
void ENC(void)
{
NewStateEnc=PINB&0b00011000;       //  
if (NewStateEnc!=OldStateEnc)      //  - ,      
{
switch(OldStateEnc)
    {
    case 24: {if(NewStateEnc==8) downEnc++; if(NewStateEnc==16) upEnc++; break;}
    case 8: {if(NewStateEnc==0) downEnc++; if(NewStateEnc==24) upEnc++; break;} 
    case 0: {if(NewStateEnc==16) downEnc++; if(NewStateEnc==8) upEnc++; break;}
    case 16: {if(NewStateEnc==24) downEnc++; if(NewStateEnc==0) upEnc++; break;} 
    }
OldStateEnc=NewStateEnc;
}
}

void TIME (void)
{
rtc_get_time(&hour, &min, &sek);
hh=5*(hour%12); //  12      
}

void DATE (void)
{
rtc_get_date(&week_day, &day, &month, &year);
}

void SYNC (void)
{
rtc_set_time(GPShour+zone, GPSmin, GPSsek);
rtc_set_date(0, GPSday, GPSmonth, GPSyear);
EEsyncday=GPSday;
LEDON;
}

// , , 
void OPROS (void)
{
ENC();                                   // 
if (Button_f) BUTTON();                  // 
if (count==2) DATE(); else TIME();       //   
}

//  
void DSKON (void)
{
Motor_on; 
GICR|=(1<<INT1);
GIFR|=(1<<INTF1);   //   
old_day=0;          //  
TCNT1=0;
TIMSK|=0b00011000;   // /1
}

//  
void DSKOFF (void)
{
Motor_off;           // 
LED_PORT&=0b11111000; // 
TIMSK&=0b11100111;   // /1
GICR&=~(1<<INT1);
GIFR&=~(1<<INTF1);   //   
}

//  
void COLR (unsigned char jj)
{
unsigned char i;
for (i=0;i<3;i++) {rgb[i]=EErgb[i+3*jj];}
}

//  
void RGB_STOP (void)
{
RGB_PORT&=0b00011111;   //  
TIMSK&=0b00111111;      // /2 
}

//
void INIT (void)
{
TIME();             // 
DATE();             // 
sat=EEsat;          //
INITDISP(sat);         // 
zone=EEtimezone;    //  
rgbN=EErgbN;        //  
COLR(rgbN);         // 
}

//     
interrupt [EXT_INT0] void ext_int0_isr(void)
{
Button_f=1;   //  
GICR&=0xBF;   // 
BTNdur=0;     //                  
}

//  
interrupt [EXT_INT1] void ext_int1_isr(void)
{
turn=TCNT1;
sekynda=52;
TCNT1=0;
OCR1A=RES;
on=turn/60;
OCR1B=on;
TIFR|=0b00011100; 
if (sek==52)SETBIT (LED_PORT,RED);
if (min==52)SETBIT (LED_PORT,BLUE);
}

//   61 
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
t=1;
}

// 
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
if (tmpEnc==7) {LED_PORT&=0b11111000;} 
 else 
    {
    if (sekynda==sek) CLRBIT (LED_PORT,RED);
    if (sekynda==min) CLRBIT (LED_PORT,BLUE);
    if (sekynda==hh) CLRBIT (LED_PORT,GREEN);
    }
OCR1A+=on;
}

//   , , 
interrupt [TIM1_COMPB] void timer1_compb_isr(void)
{
sekynda++;
if (sekynda==52) return;
if (sekynda>59) {sekynda=0; if ((tmpEnc>7)&(tmpEnc<15)) LED_PORT|=0b00000111;}
if (sekynda==sek) SETBIT (LED_PORT,RED);
if (sekynda==min) SETBIT (LED_PORT,BLUE);
if (sekynda==hh)  SETBIT (LED_PORT,GREEN);
if (tmpEnc==7) {if (!(sekynda%5)) {TGLBIT(LED_PORT,RED);TGLBIT(LED_PORT,BLUE);TGLBIT(LED_PORT,GREEN);}}
OCR1B+=on;
}

// 
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
pwm++;                       //  
if (pwm>2) pwm=0; 
if (tmpEnc>14) {SETBIT(LED_PORT, pwm);} else {SETBIT(RGB_PORT, pwm+5);}     // 
OCR2=rgb[pwm];
}

// 
interrupt [TIM2_COMP] void timer2_comp_isr(void)
{
if (tmpEnc>14) {CLRBIT(LED_PORT, pwm);} else {RGB_PORT&=0b00011111;} // 
}

// USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data;
status=UCSRA;
data=UDR;
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
   {
   if (data=='$') {rx_wr_index=0;} 
   rx_buf[rx_wr_index++]=data;
   if (data==0x0D) {gps_parse();}         //  -  ,  
   if (rx_wr_index==RX_BUFFER_SIZE) rx_wr_index=0; 
    }
}

void main(void)
{
unsigned char mode=0; //  (0 -   1 -  , 2 -   )

// Input/Output Ports initialization
// Port B initialization
// Function: Bit7=In Bit6=In Bit5=In Bit4=In Bit3=In Bit2=Out Bit1=Out Bit0=Out 
DDRB=(0<<DDB7) | (0<<DDB6) | (0<<DDB5) | (0<<DDB4) | (0<<DDB3) | (1<<DDB2) | (1<<DDB1) | (1<<DDB0);
// State: Bit7=P Bit6=P Bit5=P Bit4=P Bit3=P Bit2=0 Bit1=0 Bit0=0 
PORTB=(1<<PORTB7) | (1<<PORTB6) | (1<<PORTB5) | (1<<PORTB4) | (1<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);

// Port C initialization
// Function: Bit6=In Bit5=Out Bit4=Out Bit3=Out Bit2=Out Bit1=Out Bit0=Out 
DDRC=(0<<DDC6) | (1<<DDC5) | (1<<DDC4) | (1<<DDC3) | (1<<DDC2) | (1<<DDC1) | (1<<DDC0);
// State: Bit6=P Bit5=0 Bit4=0 Bit3=0 Bit2=0 Bit1=0 Bit0=0 
PORTC=(1<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);

// Port D initialization
// Function: Bit7=Out Bit6=Out Bit5=Out Bit4=Out Bit3=In Bit2=In Bit1=Out Bit0=In 
DDRD=(1<<DDD7) | (1<<DDD6) | (1<<DDD5) | (1<<DDD4) | (0<<DDD3) | (0<<DDD2) | (1<<DDD1) | (0<<DDD0);
// State: Bit7=0 Bit6=0 Bit5=0 Bit4=0 Bit3=P Bit2=P Bit1=0 Bit0=P 
PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (1<<PORTD3) | (1<<PORTD2) | (0<<PORTD1) | (1<<PORTD0);

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
TCCR0=(1<<CS02) | (0<<CS01) | (1<<CS00);
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 2000,000 kHz
// Mode: Normal top=0xFFFF
// OC1A output: Disconnected
// OC1B output: Disconnected
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer Period: 32,768 ms
// Timer1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: On
TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<WGM11) | (0<<WGM10);
TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (0<<CS12) | (1<<CS11) | (0<<CS10);
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 62,500 kHz
// Mode: Normal top=0xFF
// OC2 output: Disconnected
// Timer Period: 4,096 ms
ASSR=0<<AS2;
TCCR2=(0<<PWM2) | (0<<COM21) | (0<<COM20) | (0<<CTC2) | (1<<CS22) | (1<<CS21) | (0<<CS20);
TCNT2=0x00;
OCR2=0x10;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: Off
// INT1 Mode: Falling Edge
GICR|=(0<<INT1) | (1<<INT0);
MCUCR=(1<<ISC11) | (0<<ISC10) | (1<<ISC01) | (0<<ISC00);
GIFR=(0<<INTF1) | (1<<INTF0);

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: Off
// USART Mode: Asynchronous
// USART Baud Rate: 9600
UCSRA=(0<<RXC) | (0<<TXC) | (0<<UDRE) | (0<<FE) | (0<<DOR) | (0<<UPE) | (0<<U2X) | (0<<MPCM);
UCSRB=(0<<RXCIE) | (0<<TXCIE) | (0<<UDRIE) | (1<<RXEN) | (0<<TXEN) | (0<<UCSZ2) | (0<<RXB8) | (0<<TXB8);
UCSRC=(1<<URSEL) | (0<<UMSEL) | (0<<UPM1) | (0<<UPM0) | (0<<USBS) | (1<<UCSZ1) | (1<<UCSZ0) | (0<<UCPOL);
UBRRH=0x00;
UBRRL=0x67;

// Analog Comparator initialization
// Analog Comparator: Off
// The Analog Comparator's positive input is
// connected to the AIN0 pin
// The Analog Comparator's negative input is
// connected to the AIN1 pin
ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);
SFIOR=(0<<ACME);

// ADC initialization
// ADC disabled
ADCSRA=(0<<ADEN) | (0<<ADSC) | (0<<ADFR) | (0<<ADIF) | (0<<ADIE) | (0<<ADPS2) | (0<<ADPS1) | (0<<ADPS0);

// SPI initialization
// SPI disabled
SPCR=(0<<SPIE) | (0<<SPE) | (0<<DORD) | (0<<MSTR) | (0<<CPOL) | (0<<CPHA) | (0<<SPR1) | (0<<SPR0);

// TWI initialization
// TWI disabled
TWCR=(0<<TWEA) | (0<<TWSTA) | (0<<TWSTO) | (0<<TWEN) | (0<<TWIE);

// Bit-Banged I2C Bus initialization
// I2C Port: PORTC
// I2C SDA bit: 4
// I2C SCL bit: 5
// Bit Rate: 100 kHz
// Note: I2C settings are specified in the
// Project|Configure|C Compiler|Libraries|I2C menu.
i2c_init();


// DS1307 Real Time Clock initialization
// Square wave output on pin SQW/OUT: Off
// SQW/OUT pin state: 0
rtc_init(0,0,0);
//rtc_set_time(12,55,0);
//rtc_set_date(1,21,02,17);

INIT();

//Short_Press=1;
//Long_Press=1;
//mode=3;
//tmpEnc=3;

//  
TIMSK=0b00000001;

// Global enable interrupts
#asm("sei")

while (1)
      {
if (t) {OPROS(); count++; t=0;}                                  // , , 
if (sek!=old_sek) {old_sek=sek; s_f=1; count=0;} else s_f=0;     ////    
if (min!=old_min) {old_min=min; m_f=1;} else m_f=0;     //  
/**************  *********/
            
if (upEnc>=4) {tmpEnc++; upEnc=0;}       //    
if (downEnc>=4) {tmpEnc--; downEnc=0;}   //    

/******************   *********/
if (set)  {                                   //   
            if (Long_Press) {                  //   
                set=0;                         //  
                mode=0;                        //   
                tmpEnc=0;
                Long_Press=0;               
                            }
            if (Short_Press) {                 //    
                switch (mode) {
                    case 2: EEtimezone=zone;      //  
                            mode=3;               //  
                            tmpEnc=rgbN;
                            rgbN=20;
                            break;
                    case 3: RGB_STOP();
                            EErgbN=rgbN;
                            mode=4;                 //  
                            tmpEnc=sat;
                            sat=20;
                            break;
                    case 4: EEsat=sat;
                            set=0;
                            mode=0;              //
                            tmpEnc=0;
                            break;                            
                             };
                Short_Press=0;               
                              }             
            }
        else {                                 //  
            if (Long_Press) {                  //   
                set=1;                         //  
                DSKOFF();                      // 
                RGB_STOP();
                mode=2;                        //  
                tmpEnc=zone;                   //  
                zone=13;
                UCSRB&=~(1<<RXCIE); 
                Long_Press=0;               
                         }   
            if (Short_Press) {                 //    
                if (mode) {
                          DSKOFF();
                          mode=0;
                          }
                        else {
                             DSKON();
                             mode=1;
                             }
                tmpEnc=0;
                RGB_STOP();                     //  
                UCSRB&=~(1<<RXCIE);             // 
                Short_Press=0;               
                         }        
              }

/*********************** *******************/
switch (mode) {
    case 0: // ,  
            if (s_f) {                          //   
                        DATA_CONV(hour,min);    //  
                        data[1]|=(1<<7);        //0x0080; 
                        dot=1;
                        DISP();                 //  
                     }
            if ((count==22)&&dot) {dot=0; data[1]&=~(1<<7); MAX7221(data[1]);}; // 
            if (sync_start) {
                            if (!uart) {UCSRB|=1<<RXCIE; uart=1;}               //   UART  
                            if (gps) {SYNC(); UCSRB&=~(1<<RXCIE); uart=0; gps=0; sync_start=0;} //,  UART
                            } else {
                                   if (hour==10) {if(!min) {if (!sek) {uart=0; sync_start=1; LEDOFF;};};} 
                                    }         
            break;
    case 1: // ,  
            if (day!=old_day) {             //   
                        old_day=day;
                        DATA_CONV(day,month);   //  
                        data[1]|=(1<<7);        //0x0080; 
                        DISP();                 //   
                                  }     
            break;           
    case 2: //  
            if(tmpEnc>12) {tmpEnc=12;}
            if (tmpEnc!=zone) {                 //   ?
                        data[0]=0x018F;
                        data[1]=0x020F;
                        if (tmpEnc<10) {data[2]=0x030F; data[3]=0x0400|tmpEnc;} 
                            else {data[2]=0x0301; zone=tmpEnc-10; data[3]=0x0400|zone;} 
                        DISP();                 //   
                        zone=tmpEnc;
                              }
            break;                       
    case 3: //  
            TIMSK|=0b11000000;   // /2                  
            if(tmpEnc>COLORS) {tmpEnc=COLORS;}
            if (tmpEnc!=rgbN) {
                COLR(tmpEnc);                                 // 
                data[0]=0x010F;
                data[1]=0x028F;
                if (tmpEnc<10) {data[2]=0x030F; data[3]=0x0400|tmpEnc;} 
                            else {data[2]=0x0301; rgbN=tmpEnc-10; data[3]=0x0400|rgbN;} 
                DISP();                 //   
                rgbN=tmpEnc;
                              }
            break;
    case 4: //  
            if(tmpEnc>0x0F) {tmpEnc=0x0F;}
            if (tmpEnc!=sat) {                 //  ?
                        data[0]=0x010F;
                        data[1]=0x020F;
                        if (tmpEnc<10) {data[2]=0x038F; data[3]=0x0400|tmpEnc;} 
                            else {data[2]=0x0381; sat=tmpEnc-10; data[3]=0x0400|sat;} 
                        DISP();                 //   
                        sat=tmpEnc;
                        MAX7221(0x0A00|sat);
                              }
            break;                  
            };
/*********************** **********************************/       
if (!set) {             //   
      if (!mode) {      //  
        if(tmpEnc>8) tmpEnc=8;
        switch (tmpEnc) {
            case 0: // 
                    RGB_STOP(); 
                    break;
            case 1: //  
                    if (rgbN!=EErgbN) {rgbN=EErgbN; COLR(rgbN);}
                    break;
            case 2: //    
                    if (s_f) {rgbN++; if (rgbN>COLORS) rgbN=0; COLR(rgbN);}
                    break;
            case 3: //    
                    rgb[0]=240-4*count;
                    rgb[1]=240-4*count;
                    rgb[2]=240-4*count;
                    break;
            case 4: //BLUE    
                    rgb[0]=240-4*count;
                    rgb[1]=0;
                    rgb[2]=0;
                    break; 
            case 5: //RED    
                    rgb[0]=0;
                    rgb[1]=240-4*count;
                    rgb[2]=0;
                    break; 
            case 6: //GREEN    
                    rgb[0]=0;
                    rgb[1]=0;
                    rgb[2]=240-4*count;
                    break;          
            case 7: // 
                    if (s_f) {
                            rgb[0]++;
                            rgb[1]=4*rgb[0];
                            rgb[2]--;
                            if (!rgb[2]) {
                                    rgb[2]=254;
                                    rgb[0]=0;
                                         }
                             }
                    break;
            case 8: //    
                    if (m_f) {rgbN++; if (rgbN>COLORS) rgbN=0; COLR(rgbN);}
                    break;                                           
                         };
        if (tmpEnc) TIMSK|=0b11000000;   // /2                   
                } else { // 
                        if(tmpEnc>16) tmpEnc=16;
                        switch (tmpEnc) {
                            case 0: // 
                                CLRBIT(RGB_PORT,BL); 
                                break;
                            case 1: // 
                                SETBIT(RGB_PORT,BL);
                                CLRBIT(RGB_PORT,RD);
                                break;
                            case 2: // 
                                SETBIT(RGB_PORT,RD);
                                CLRBIT(RGB_PORT,BL);
                                CLRBIT(RGB_PORT,GR);
                                break;
                            case 3: // 
                                SETBIT(RGB_PORT,GR);
                                CLRBIT(RGB_PORT,RD);
                                break;
                            case 4: // 
                                SETBIT(RGB_PORT,RD);
                                CLRBIT(RGB_PORT,BL);
                                break;
                            case 5: // 
                                SETBIT(RGB_PORT,BL);
                                CLRBIT(RGB_PORT,GR);
                                break;
                            case 6: // 
                                SETBIT(RGB_PORT,GR);
                                SETBIT(RGB_PORT,BL);
                                break;
                            case 7: // 5 
                                CLRBIT(RGB_PORT,RD);
                                CLRBIT(RGB_PORT,BL);
                                CLRBIT(RGB_PORT,GR);
                                break;                                
                            case 8: //   
                                CLRBIT(RGB_PORT,BL);
                                break;
                            case 9: // 
                                SETBIT(RGB_PORT,BL);
                                CLRBIT(RGB_PORT,GR);
                                CLRBIT(RGB_PORT,RD);
                                break;
                            case 10: // 
                                SETBIT(RGB_PORT,RD);
                                CLRBIT(RGB_PORT,BL);
                                CLRBIT(RGB_PORT,GR);
                                break;
                            case 11: // 
                                SETBIT(RGB_PORT,GR);
                                CLRBIT(RGB_PORT,RD);
                                break;
                            case 12: // 
                                SETBIT(RGB_PORT,RD);
                                CLRBIT(RGB_PORT,BL);
                                break;
                            case 13: // 
                                SETBIT(RGB_PORT,BL);
                                CLRBIT(RGB_PORT,GR);
                                break;
                            case 14: // 
                                SETBIT(RGB_PORT,GR);
                                CLRBIT(RGB_PORT,RD);
                                TIMSK&=0b00111111;
                                break;
                            case 15: //
                                rgbN=30;
                                rgb[0]=10;
                                rgb[1]=10;
                                rgb[2]=10;
                                TIMSK|=0b11000000;
                                break;
                            case 16:
                                if (s_f) {
                                    rgb[0]++;
                                    rgb[1]=4*rgb[0];
                                    rgb[2]--;
                                    if (!rgb[2]) {
                                        rgb[2]=254;
                                        rgb[0]=0;}
                                         }
                                break;                                                                      
                                        };
                        } 
          }
       
       }
}


