#define SPI_PORT PORTC
#define SCK 0
#define SDI 2
#define nSS 1
#define HI(x) SETBIT(SPI_PORT, x)  //    7 
#define LO(x) CLRBIT(SPI_PORT, x)

unsigned int data[]={0x0100, 0x0200, 0x0300, 0x0400}; //   Hh Hl Mh Ml

//    
void DATA_CONV(unsigned char High, unsigned char Low)         
{    
unsigned char tmp;
tmp=High/10;    
data[0]=0x0100|tmp; // 
tmp=High%10;
data[1]=0x0200|tmp; //
tmp=Low/10;
data[2]=0x0300|tmp; //
tmp=Low%10;
data[3]=0x0400|tmp; // 
}

//   MAX7221
void MAX7221 (unsigned int cmd)
{
    unsigned char i;
#asm("cli") 
    LO(SCK);
    LO(nSS);
    for (i=0; i<16; i++)
        {
        if(cmd&0x8000) HI(SDI) else LO(SDI)
        HI(SCK);
        delay_us(1);
        LO(SCK);
        cmd<<=1;
        }
    LO(SDI);
    LO(SCK);
    HI(nSS);
#asm("sei") 
}

//    
void DISP(void)         
{    
unsigned char i;
for(i=0;i<4;i++) MAX7221(data[i]);
}

//   
void INITDISP (unsigned char s)
{
HI(nSS);         //  1
delay_ms(10);
MAX7221(0x0C00); // 
MAX7221(0x09FF); // BCDcode
MAX7221(0x0A00|s); //  
MAX7221(0x0B03); // 
MAX7221(0x0F00); //  .
MAX7221(0x0C01); // 
}